// Package com_docusign_connect_0_4_0 contains domain objects and was generated from Concerto namespace com.docusign.connect@0.4.0.
package com_docusign_connect_0_4_0
import "time"
import "org_accordproject_runtime_0_2_0";
import "org_accordproject_binary_0_2_0";
import "concerto_1_0_0";
   
type EnvelopeStatusCode int
const (
   Any EnvelopeStatusCode = 1 + iota
   Voided
   Created
   Deleted
   Sent
   Delivered
   Signed
   Completed
   Declined
   TimedOut
   Template
   Processing
)
type RecipientStatusCode int
const (
   Created RecipientStatusCode = 1 + iota
   Sent
   Delivered
   Signed
   Declined
   Completed
   FaxPending
   AutoResponded
)
type TabTypeCode int
const (
   InitialHere TabTypeCode = 1 + iota
   SignHere
   FullName
   FirstName
   LastName
   EmailAddress
   Company
   Title
   DateSigned
   InitialHereOptional
   EnvelopeID
   Custom
   SignerAttachment
   SignHereOptional
   Approve
   Decline
   SignerAttachmentOptional
   DigitalSignature
)
type CustomTabTypeCode int
const (
   Text CustomTabTypeCode = 1 + iota
   Checkbox
   Radio
   List
   Date
   Number
   SSN
   ZIP5
   ZIP5DASH4
   Email
   Note
   Formula
)
type DocumentType int
const (
   Principal DocumentType = 1 + iota
   CertificateOfCompletion
   SignerAttachment
)
type EnvelopeStatus struct {
   concerto_1_0_0.Concept
   Status EnvelopeStatusCode `json:"status"`
   EnvelopeId string `json:"envelopeId"`
   Created time.Time `json:"created"`
   Sent time.Time `json:"sent"`
   Delivered time.Time `json:"delivered"`
   Signed time.Time `json:"signed"`
   Completed time.Time `json:"completed"`
   Declined time.Time `json:"declined"`
   Email string `json:"email"`
}
type Recipient struct {
   concerto_1_0_0.Concept
   Status RecipientStatusCode `json:"status"`
   Email string `json:"email"`
   UserName string `json:"userName"`
   Sent time.Time `json:"sent"`
   Delivered time.Time `json:"delivered"`
   Signed time.Time `json:"signed"`
   Declined time.Time `json:"declined"`
   DeclineReason string `json:"declineReason"`
   TabStatuses []TabStatus `json:"tabStatuses"`
}
type CustomField struct {
   concerto_1_0_0.Concept
   Name string `json:"name"`
   Value string `json:"value"`
}
type TabStatus struct {
   concerto_1_0_0.Concept
   TabType TabTypeCode `json:"tabType"`
   Status string `json:"status"`
   TabLabel string `json:"tabLabel"`
   OriginalValue string `json:"originalValue"`
   Signed time.Time `json:"signed"`
   CustomTabType CustomTabTypeCode `json:"customTabType"`
}
type NumberTabStatus struct {
   TabStatus
   TabName string `json:"tabName"`
   TabValue float64 `json:"tabValue"`
}
type TextTabStatus struct {
   TabStatus
   TabName string `json:"tabName"`
   TabValue string `json:"tabValue"`
}
type DateTabStatus struct {
   TabStatus
   TabName string `json:"tabName"`
   TabValue time.Time `json:"tabValue"`
}
type BooleanTabStatus struct {
   TabStatus
   TabName string `json:"tabName"`
   TabValue bool `json:"tabValue"`
}
type ListTabStatus struct {
   TabStatus
   TabNames []string `json:"tabNames"`
   TabValue string `json:"tabValue"`
   ListValues []string `json:"listValues"`
   ListSelectedValue string `json:"listSelectedValue"`
}
type Attachment struct {
   org_accordproject_binary_0_2_0.BinaryResource
   DocType DocumentType `json:"docType"`
}
type DocuSignEnvelopeInformation struct {
   org_accordproject_runtime_0_2_0.Request
   EnvelopeStatus EnvelopeStatus `json:"envelopeStatus"`
   Recipients []Recipient `json:"recipients"`
   CustomFields []CustomField `json:"customFields"`
   Attachments []Attachment `json:"attachments"`
}
